<template>
  <b-container fluid>
    <b-row>
      <!-- tab search -->
      <b-col cols="4">
        <!-- title search -->
        <b-card-title id="titleSearch"
          ><b-img
            src="https://cdn2.iconfinder.com/data/icons/ios-7-icons/50/search-512.png"
            height="30px"
            id="imgLogoSearch"
          ></b-img>
          <h5>ค้นหางาน</h5></b-card-title
        >
        <b-card-body id="bodySearch">
          <form ref="form">
            <b-row class="colSearch">
              <b-col>
                <b-row>ประเภทงาน</b-row>
                <b-row
                  ><b-form-select
                    id="workType"
                    v-model="form.workType"
                    :options="optionsWorkType"
                    required
                  ></b-form-select
                ></b-row>
              </b-col>
            </b-row>
            <b-row class="colSearch"
              ><b-col>
                <b-row>จังหวัด</b-row>
                <b-row
                  ><b-form-select
                    id="province"
                    v-model="form.province"
                    :options="optionsProvince"
                    required
                  ></b-form-select
                ></b-row> </b-col
            ></b-row>
            <b-row class="colSearch">
              <b-col>
                <b-row>อำเภอ/เขต</b-row>
                <b-row
                  ><b-form-select
                    id="district"
                    v-model="form.district"
                    :options="optionsDistrict"
                    required
                  ></b-form-select
                ></b-row>
              </b-col>
            </b-row>
            <b-row class="colSearch">
              <b-col>
                <b-row>คำที่ต้องการค้นหา</b-row>
                <b-row
                  ><b-form-input
                    v-model="form.findWord"
                    placeholder="เช่น บัญชี"
                  ></b-form-input
                ></b-row>
              </b-col>
            </b-row>
            <b-row class="colSearch">
              <b-col id="colBtnSearch">
                <b-button
                  variant="success"
                  @click="handleSubmit()"
                  id="btnSearch"
                  >ค้นหางาน</b-button
                >
              </b-col>
            </b-row>
          </form>
        </b-card-body>
      </b-col>
      <!-- detail for searching -->
      <b-col>
        <b-row>
          <b-col id="colH3"
            ><h3>งานทั้งหมด {{ countDeclares }} อัตรา</h3></b-col
          >
        </b-row>
        <!-- all button -->
        <b-row class="rowBtnGroup">
          <b-button variant="light" class="btnGroup" @click="getBangkok()"
            >กรุงเทพ</b-button
          >
          <b-button variant="light" class="btnGroup" @click="getEast()"
            >ชลบุรี</b-button
          >
          <b-button variant="light" class="btnGroup" @click="getCentralRegion()"
            >นนทบุรี</b-button
          >
          <b-button variant="light" class="btnGroup" @click="getNortheast()"
            >ขอนแก่น</b-button
          >
        </b-row>
        <b-row class="rowBtnGroup">
          <b-button variant="light" class="btnGroup" @click="getNorth()"
            >เชียงใหม่</b-button
          >
          <b-button variant="light" class="btnGroup" @click="getSouth()"
            >ภูเก็ต</b-button
          >
          <b-button variant="secondary" class="btnGroup" @click="getAll()"
            >ทั้งหมด</b-button
          >
        </b-row>
        <b-row v-if="declareList.length > 0">
          <div v-for="declare in declareList" :key="declare.id" id="posting">
            <b-col cols="6" id="declareOne">
              <b-card>
                <b-row>
                  <!-- img -->
                  <b-col cols="4" id="setBoderMini"
                    ><b-card-img
                      src="https://www.nicepng.com/png/full/192-1921815_-corgi-cartoon-face.png"
                    ></b-card-img
                  ></b-col>
                  <!-- detail -->
                  <b-col id="dataDetail">
                    <b-row>
                      <b-col cols="3"
                        ><b-img
                          width="25%"
                          src="https://training-saraburi.cdd.go.th/wp-content/uploads/sites/149/2018/08/person-outline-icon-png-person-outline-icon-png-person-17.png"
                        ></b-img
                      ></b-col>
                      <b-col
                        ><b> {{ declare.position.positionName }}</b></b-col
                      >
                    </b-row>
                    <b-row>ประเภทงาน : {{ declare.position.workType }}</b-row>
                    <b-row>
                      <b-col cols="4" id="setCol" v-if="declare.position.gender === 'F'"
                        >เพศ : หญิง</b-col
                      >
                      <b-col cols="4" id="setCol" v-else-if="declare.position.gender === 'M'"
                        >เพศ : ชาย</b-col
                      >
                      <b-col cols="4" id="setCol" v-else
                        >เพศ : ไม่ระบุ</b-col
                      >
                      <b-col id="setCol"
                        >อายุ :
                        {{ declare.position.age }}
                        ปี</b-col
                      >
                    </b-row>
                    <b-row
                      ><b-col cols="4" id="setCol"
                        >อัตรา : {{ declare.position.rate }}</b-col
                      >
                      <b-col id="setCol"
                        >เงินเดือน :
                        {{ declare.position.salary }}
                        บาท</b-col
                      ></b-row
                    >
                    <b-row>ลงวันที่ {{ declare.dateStart }}</b-row>
                  </b-col>
                </b-row>
                <b-row id="btnDetail"
                  ><router-link
                    :to="{ name: 'DetailDeclareApplicant', params: { id: declare.id } }"
                    ><b-button variant="info"
                      >ดูข้อมูลเพิ่มเติม</b-button
                    ></router-link
                  ></b-row
                >
              </b-card>
            </b-col>
          </div>
        </b-row>
        <b-row v-else id="notFound">ไม่พบประกาศที่ตรงกับการค้นหา</b-row>
      </b-col>
    </b-row>
  </b-container>
</template>
<style>
#titleSearch {
  display: flex;
  border: solid 1px #ebebe0;
  padding: 5px;
  margin: 5px;
  margin-bottom: 0;
}
#imgLogoSearch {
  margin-right: 15px;
}
.card-body {
  margin-top: 20px;
}
#bodySearch {
  border: solid 1px #ebebe0;
  padding: 30px;
  margin: 5px;
  margin-top: 0;
}
.colSearch {
  margin-top: 20px;
}
#btnSearch {
  width: 70%;
}
#colBtnSearch {
  display: flex;
  justify-content: center;
}
#colH3 {
  border-bottom: solid rgb(185, 185, 185) 5px;
  width: 100%;
  margin-top: 10px;
  margin-bottom: 20px;
}
h3 {
  padding-left: 40px;
}
.btnGroup {
  padding: 5px;
  padding-left: 40px;
  padding-right: 40px;
  border-radius: 15px;
  margin: 5px;
}
.rowBtnGroup {
  display: flex;
  justify-content: center;
  padding-left: 20px;
  padding-right: 20px;
}
#setBoderMini {
  border: solid gray 2px;
  background-color: rgb(233, 233, 233);
  width: 60%;
  padding: 10px;
  display: flex;
  justify-content: center;
  margin-right: 10px;
}
#dataDetail {
  font-size: 12px;
}
#declareOne {
  padding: 2px;
  max-width: -webkit-fill-available;
}
#btnDetail {
  display: flex;
  justify-content: flex-end;
}
#setCol {
  padding: 0px;
}
#posting {
  display: contents;
  width: 33%;
}
img.card-img {
  width: 60%;
}
#notFound {
  color: gray;
  display: flex;
  justify-content: center;
  margin-top: 10px;
}
</style>
<script>
import declareService from '../Service/declarList'
// import companyService from '../Service/company'
import axios from 'axios'
export default {
  data () {
    return {
      form: {
        workType: null,
        province: null,
        district: null,
        findWord: ''
      },
      optionsWorkType: [
        { text: 'ทั้งหมด', value: null }
        // ,
        // { value: 'การเงิน', text: 'การเงิน' },
        // { value: 'ธุรการ', text: 'ธุรการ' }
      ],
      optionsProvince: [
        { text: 'ทั้งหมด', value: null },
        { value: 'กรุงเทพ', text: 'กรุงเทพ' },
        { value: 'ชลบุรี', text: 'ชลบุรี' },
        { value: 'นนทบุรี', text: 'นนทบุรี' },
        { value: 'ขอนแก่น', text: 'ขอนแก่น' },
        { value: 'เชียงใหม่', text: 'เชียงใหม่' },
        { value: 'ภูเก็ต', text: 'ภูเก็ต' }
      ],
      optionsDistrict: [
        { text: 'ทั้งหมด', value: null }
        // ,
        // { value: 'เมือง', text: 'เมือง' },
        // { value: 'F', text: 'Female' }
      ],
      countDeclares: 0,
      declareList: [],
      companies: [],
      currentDeclares: []
    }
  },
  methods: {
    handleSubmit () {
      // console.log(this.form)
      // this.declareList = []
      // this.declareList = declareService.getSearching(
      //   this.form.workType,
      //   this.form.province,
      //   this.form.district,
      //   this.form.findWord
      // )
      // this.reset()
      if (
        this.form.workType == null &&
        this.form.province == null &&
        this.form.district == null &&
        this.form.findWord === ''
      ) {
        this.getAll()
        this.reset()
      }
      if (
        this.form.workType == null &&
        this.form.province === 'กรุงเทพ' &&
        this.form.district == null &&
        this.form.findWord === ''
      ) {
        this.getBangkok()
        this.reset()
      }
      if (
        this.form.workType == null &&
        this.form.province === 'ชลบุรี' &&
        this.form.district == null &&
        this.form.findWord === ''
      ) {
        this.getEast()
        this.reset()
      }
      if (
        this.form.workType == null &&
        this.form.province === 'นนทบุรี' &&
        this.form.district == null &&
        this.form.findWord === ''
      ) {
        this.getCentralRegion()
        this.reset()
      }
      if (
        this.form.workType == null &&
        this.form.province === 'ขอนแก่น' &&
        this.form.district == null &&
        this.form.findWord === ''
      ) {
        this.getNortheast()
        this.reset()
      }
      if (
        this.form.workType == null &&
        this.form.province === 'เชียงใหม่' &&
        this.form.district == null &&
        this.form.findWord === ''
      ) {
        this.getNorth()
        this.reset()
      }
      if (
        this.form.workType == null &&
        this.form.province === 'ภูเก็ต' &&
        this.form.district == null &&
        this.form.findWord === ''
      ) {
        this.getSouth()
        this.reset()
      }
    },
    reset () {
      this.form = {
        workType: null,
        province: null,
        district: null,
        findWord: ''
      }
    },
    getAll () {
      this.declareList = []
      this.declareList = declareService.getDeclares()
      // axios.get('http://127.0.0.1:3000/declare').then(res => {
      //   console.log('length')
      //   console.log(res.data.length)
      //   this.declareList = res.data
      //   this.countDeclares = res.data.length
      // })
    },
    getBangkok () {
      // this.declareList = []
      // this.declareList = declareService.getDeclaresBangkok()
      // console.log('BangKok')
      // console.log(this.declareList)
      axios.get('http://127.0.0.1:3000/declare/1').then(res => {
        console.log('length')
        console.log(res.data.length)
        this.declareList = res.data
        this.countDeclares = res.data.length
      })
    },
    getEast () {
      // this.declareList = []
      // this.declareList = declareService.getDeclaresEast()
      // console.log('East')
      // console.log(this.declareList)
      axios.get('http://127.0.0.1:3000/declare/2').then(res => {
        console.log('length')
        console.log(res.data.length)
        this.declareList = res.data
        this.countDeclares = res.data.length
      })
    },
    getNorth () {
      // this.declareList = []
      // this.declareList = declareService.getDeclaresNorth()
      // console.log('North')
      // console.log(this.declareList)
      axios.get('http://127.0.0.1:3000/declare/5').then(res => {
        console.log('length')
        console.log(res.data.length)
        this.declareList = res.data
        this.countDeclares = res.data.length
      })
    },
    getNortheast () {
      // this.declareList = []
      // this.declareList = declareService.getDeclaresNortheast()
      // console.log('Northeast')
      // console.log(this.declareList)
      axios.get('http://127.0.0.1:3000/declare/4').then(res => {
        console.log('length')
        console.log(res.data.length)
        this.declareList = res.data
        this.countDeclares = res.data.length
      })
    },
    getCentralRegion () {
      // this.declareList = []
      // this.declareList = declareService.getDeclaresCentralRegion()
      // console.log('Central region')
      // console.log(this.declareList)
      axios.get('http://127.0.0.1:3000/declare/3').then(res => {
        console.log('length')
        console.log(res.data.length)
        this.declareList = res.data
        this.countDeclares = res.data.length
      })
    },
    getSouth () {
      // this.declareList = []
      // this.declareList = declareService.getDeclaresSouth()
      // console.log('South')
      // console.log(this.declareList)
      axios.get('http://127.0.0.1:3000/declare/6').then(res => {
        console.log('length')
        console.log(res.data.length)
        this.declareList = res.data
        this.countDeclares = res.data.length
      })
    }
  },
  computed: {},

  mounted () {
    console.log('Vue is Job Searching page')
    // this.countDeclares = declareService.getCountDeclares()
    axios.get('http://127.0.0.1:3000/declare').then(res => {
      console.log('length')
      console.log(res.data.length)
      this.countDeclares = res.data.length
    })
    console.log('All declares is ', this.countDeclares)
    axios.get('http://127.0.0.1:3000/declare').then(res => {
      console.log(res.data)
      this.declareList = res.data
    })
  }
}
</script>
